import { ClashProviderConfig, HttpNodeConfig, HttpsNodeConfig, ShadowsocksNodeConfig, ShadowsocksrNodeConfig, SnellNodeConfig, SubscriptionUserinfo, TrojanNodeConfig, TuicNodeConfig, VmessNodeConfig } from '../types';
import Provider from './Provider';
declare type SupportConfigTypes = ShadowsocksNodeConfig | VmessNodeConfig | HttpsNodeConfig | HttpNodeConfig | ShadowsocksrNodeConfig | SnellNodeConfig | TrojanNodeConfig | TuicNodeConfig;
export default class ClashProvider extends Provider {
    readonly _url: string;
    readonly udpRelay?: boolean;
    readonly tls13?: boolean;
    constructor(name: string, config: ClashProviderConfig);
    get url(): string;
    getSubscriptionUserInfo({ requestUserAgent, }?: {
        requestUserAgent?: string;
    }): Promise<SubscriptionUserinfo | undefined>;
    getNodeList({ requestUserAgent, }?: {
        requestUserAgent?: string;
    }): Promise<ReadonlyArray<SupportConfigTypes>>;
}
export declare const getClashSubscription: ({ url, udpRelay, tls13, requestUserAgent, }: {
    url: string;
    udpRelay?: boolean | undefined;
    tls13?: boolean | undefined;
    requestUserAgent?: string | undefined;
}) => Promise<{
    readonly nodeList: ReadonlyArray<SupportConfigTypes>;
    readonly subscriptionUserinfo?: SubscriptionUserinfo;
}>;
export declare const parseClashConfig: (proxyList: ReadonlyArray<any>, udpRelay?: boolean, tls13?: boolean) => ReadonlyArray<SupportConfigTypes>;
export {};
