import NodeCache from 'node-cache';
import { SubscriptionUserinfo } from '../types';
export interface SubsciptionCacheItem {
    readonly body: string;
    subscriptionUserinfo?: SubscriptionUserinfo;
}
export declare const ConfigCache: NodeCache;
export declare const SubscriptionCache: NodeCache;
export declare class RedisCache {
    namespace?: string | undefined;
    private redisClient;
    constructor(namespace?: string | undefined);
    getCacheKey(key: string): string;
    setCache: (key: string, value: unknown, { ttl }?: {
        ttl?: number | undefined;
    }) => Promise<void>;
    getCache: <T>(key: string) => Promise<T | undefined>;
    hasCache: (key: string) => Promise<boolean>;
    deleteCache: (key: string) => Promise<void>;
}
export declare const cleanCaches: () => Promise<void>;
